<?php
require_once __DIR__ . '/../vendor/autoload.php';

use \Slim\Container;
use \Slim\App;

$container = new Container();

$container['errorHandler'] 		= function($container) {
								return function ($request, $response, $exception) use ($container) {
									 $mensaje = [
											"code" => $exception->getCode(),
											"message" => $exception->getMessage(),
											"noError" => null,
									];
								    if(isset($exception->errorInfo)){

										if($exception->errorInfo[1] == 1062)
										{
												$codigo = explode(' ', $exception->errorInfo[2]);

												$mensaje["message"] = " El dato $codigo[2] ya esta regitrado, duplicidad de informacion ";
										}
										if($exception->errorInfo[1] == 1048)
										{
												$campo = explode(' ', $exception->errorInfo[2]);

												$mensaje["message"] = " El dato $campo[1] viene sin informacion  ";
										}
										if($exception->errorInfo[1] == 4025)
										{
												$campo = explode(' ', $exception->errorInfo[2]);

												$mensaje["message"] = " El dato $campo[1] viene vacio ";
										}
										$mensaje["noError"] = $exception->errorInfo[1];

									}
									return $response
									->withStatus(500)
									->withHeader('content-type', 'application/json')
									->write(json_encode($mensaje));
								};
							};
$container['notFoundHandler'] 	= function($container) {
									return function($request, $response) use ($container) {
										return $response->withStatus(404)
										->withHeader('content-type', 'text/html')
										->write('pagina no encontrada!!');
									};
							};
$container['notAllwedHandler'] 	= function($container) {
									return function ($request, $response, $methods) use ($container) {
										return $response->withStatus(405)
										->withHeader('Allow', implode(', ', $methods))
										->withHeader('content-type', 'text/html')
										->write('El metodo must be one of:' . implode(',', $methods));
								};
							};
$container['phpErrorHandler'] 	= function($container) {
									return function($request, $response, $error) use ($container) {
										return $response->withStatus(500)
										->withHeader('content-type', 'text/html')
										->write($error); //paso algo mas
									};
							};
							
$container['settings']['displayErrorDetails'] = true;


$container['settings']['db']=[
							'driver' => 'mysql',
							'host' => 'localhost',
							'port' => '3306',
							'database' => 'biotech9_dbcctest',
							'username' => 'biotech9_admin',
							'password' => 'administrador',
							'charset' => 'utf8',
							'collation' => 'utf8_unicode_ci',
							'prefix' => ''];
								
require_once __DIR__ . '/../src/config/database.php';

$app = new App($container);

require_once __DIR__ . '/../src/Routers/Web.php';

$app->run();
