<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;
use \Psr\Http\Message\UploadedFileInterface as UploadedFile;

use App\Models\Antibiotico;

class AntibioticosController
{
	public function ReadAll(Request $request, Response $response, $args)
  {
    $antibioticos = Antibiotico::all();

    return $response->getBody()->write( json_encode($antibioticos) );
  }
  public function Create(Request $request, Response $response, $args)
  {
    $antibioticoNuevo = $request->getParsedBody();

    $antibiotico = Antibiotico::create($antibioticoNuevo);

    return $response->getBody()->write(json_encode($antibiotico));
  }
  public function Read(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');
    
    $antibiotico = Antibiotico::find($id);

    return $response->getBody()->write(json_encode($antibiotico));
  }
  public function Update(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');
    $antibioticoUpdate = $request->getParsedBody();

    $antibiotico = Antibiotico::find($id);
    $antibiotico->update($antibioticoUpdate);

    return $response->getBody()->write(json_encode($antibiotico));
  }
  public function Delete(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');
    
    $antibiotico = Antibiotico::find($id);
    $antibiotico->delete();

    return $response->getBody()->write(json_encode($antibiotico));
  }
}