<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;
use \Psr\Http\Message\UploadedFileInterface as UploadedFile;

use App\Models\Batch;
use App\Models\Producto;

class BatchsController
{

	public function ReadAll( Request $request, Response $response, $args)
	{
		$batchs = Batch::all();

		return $response->getBody()->write( json_encode($batchs) );
	}

	public function Create(	Request $request, Response $response, $args)
	{
		$nuevoBatch = $request->getParsedBody();

		$batch = Batch::create($nuevoBatch);

		return $response->getBody()->write( json_encode($batch) );
	}

	public function Read( Request $request, Response $response, $args)
	{
		$id = $request->getAttribute('id');

		$batch = Batch::find($id);

		return $response->getBody()->write( json_encode($batch) );
	}

	public function Update( Request $request, Response $response, $args)
	{
		$id = $request->getAttribute("id");
		$batchActualizar = $request->getParsedBody();

		$batch = Batch::find($id);
		$batch->update($batchActualizar);

		return $response->getBody()->write( json_encode($batch) );
	}

	public function Delete( Request $request, Response $response, $args)
	{
		$id = $request->getAttribute('id');

    	$batch = Batch::find($id);
    	$batch->delete();

    	return $response->getBody()->write(json_encode($batch));
	}
  //funcionlidad cancelada
	public function BatchInProductos( Request $request, Response $response, $args)
	{
		/* 				Recibir encabezados
			$aut = $request->getHeaders();
			$aut = $request->getHeaderLine('Authorization');
		*/
		/*	primera opcion */

		$batchs = Producto::select('noBatch')->distinct();
		$batchIn = Batch::whereIn('noBatch', $batchs)->get();

		//$batchIn = Batch::where('noafectado','!=', 0)->get();

 		return $response->getBody()->write( json_encode($batchIn) );
	}
 //funcionalidad cancelada
	public function BatchNotInProductos( Request $request, Response $response, $args)
	{

		/* primera opcion
		$batchs = Producto::select('batch')->distinct();
		$batchNotIn = Batch::whereNotIn('idbatch', $batchs)->get();
		*/

		$batchNotIn = Batch::where('noafectado', 0)->get();

		return $response->getBody()->write( json_encode($batchNotIn) );
	}
  //funcionalidad cancelada
	public function BatchToBatch( Request $request, Response $response, $args)
	{
				$idO = $request->getAttribute('idO');
				$idN = $request->getAttribute('idN');

				$respuesta = ['code' => 0, 'affected' => 0];

				$batch = Batch::find($idN);

				$actualizar = [
												'batch'=> $batch->idbatch,
												'nofactura' => $batch->nofactura,
												'fecha'=> $batch->fecha,
												'fk_institucion' => $batch->fk_institucion,
												'statusMov' => 2,
												'fechaMov' => '2021-09-14'
											];

				//$affected = Producto::where('batch', $idO)->where('on_row', 1)->whereNull('acumulado->id_producto')->update($actualizar);

				$affected = Producto::where('noBatch', $idO)->where('status', 1)->whereNull('CasosProductos.id_producto')->leftjoin('CasosProductos', 'Productos.id', '=','CasosProductos.id_producto')->update($actualizar);

				if($affected)
				{
					$respuesta['code'] = 1;
					$respuesta['affected'] = $affected;
					$batch->noafectado = $affected;

					$batch->save();
				}

		return $response->getBody()->write( json_encode($respuesta) );
	}
}
