<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\CasoClinico;
use App\Models\CasoProducto;
use Carbon\Carbon;

class CasosProductosController
{

	public function ReadAll(Request $request, Response $response, $args)
	{
	    $productos = CasoProducto::all();
      $productos->loadMissing(['producto', 'casoclinico', 'medico', 'enfermera']);

	    return $response->getBody()->write(json_encode($productos));
	}
	public function Create(Request $request, Response $response, $args)
	{
	      $producto = $request->getParsedBody();
	      $producto = CasoProducto::Create($producto);

	      return $response->getBody()->write(json_encode($producto));
	}
	public function Read(Request $request, Response $response, $args)
	{
    $id = $request->getAttribute('id', '0');

    $casoproducto = CasoProducto::find($id);

    return $response->getBody()->write(json_encode($CasoProducto));
	}
	public function Update(Request $request, Response $response, $args)
	{
    $id = $request->getAttribute('id');

    $producto = $request->getParsedBody();

    $casoProducto = CasoProducto::find($id);

    $casoProducto->save();

  	return $response->getBody()->write(json_encode($casoProducto));
	}
	public function Delete(Request $request, Response $response, $args)
	{
  	$id = $request->getAttribute('id');

    	$casoProducto=CasoProducto::destroy($id);

  	//$producto = Producto::find($id);   $producto->delete();
   	return $response->getBody()->write(json_encode($casoProducto));
	}

  	public function UpdatePuntosMedico(Request $request, Response $response, $args)
  	{
  		$res = ["code" => 0, "message" => "" , "data" => null];

  		$id = $request->getAttribute('id');
  		$puntos = $request->getParam('puntos'); // $args['codigo'];

  		$casosProducto = CasoProducto::find($id);

  		$casosProducto->puntos = $puntos;

  		if($casosProducto->save()){
  			$res["code"] = 1;
  			$res["message"] = "Registro con exito";
  			$res["data"] = $casosProducto;
  		}else{
  			$res["code"] = 0;
  			$res["message"] = "No se registro";
  			$res["data"] = $casosProducto;
  		}

  		return $response->getBody()->write(json_encode($res));
  	}

    public function UpdatePuntosEnfermera(Request $request, Response $response, $args)
    {
      $res = ["code" => 0, "message" => "" , "data" => null];

      $id = $request->getAttribute('id');
      $e_puntos = $request->getParam('e_puntos'); // $args['codigo'];

      $casosProducto = CasoProducto::find($id);

      $casosProducto->e_puntos = $e_puntos;

      if($casosProducto->save()){
        $res["code"] = 1;
        $res["message"] = "Registro con exito";
        $res["data"] = $casosProducto;
      }else{
        $res["code"] = 0;
        $res["message"] = "No se registro";
        $res["data"] = $casosProducto;
      }

      return $response->getBody()->write(json_encode($res));
    }

    public function InsertCasoProductos(Request $request, Response $response, $args)
    {
      $res = ["code" => 0, "message" => "" , "data" => null];
      $cps = [];

      $productos = $request->getParsedBody();

      foreach ($productos  as $key => $elemento) {
            $elemento["acumulado"]["fechaRegistro"] = Carbon::now();
            $cps[] = $elemento["acumulado"];
      }

      $r = CasoProducto::insert($cps);

      $this->Correo_Codigo($productos[0]["acumulado"]["id_casoClinico"]);

      if($r) {
        $res["code"] = 1;
        $res["message"] = "Registro con exito";
        $res["data"] = $cps;
      }else{
        $res["code"] = 0;
        $res["message"] = "No se registro";
        $res["data"] = $cps;
      }

      return $response->getBody()->write(json_encode($res));
    }

    private function Correo_Codigo($id)
    {
      $casoClinico = CasoClinico::find($id);

      $casoClinico->loadMissing(['medico', 'productos', 'enfermera']);

      $sCodigo = "<ul>";
      $enfermera = "";

      foreach ($casoClinico->productos as $k => $producto)
      {
          $sCodigo = $sCodigo . "<li> $producto->codigo  $producto->nomProducto</li>";
      }

      $para_medico = $casoClinico->medico->correo;

      $para_alertas = 'alertas_cc@biotechsa.com';

      $medico = $casoClinico->medico->nombre . " " . $casoClinico->medico->primerApellido;
      $folio = $casoClinico->folio;
      $serie = $casoClinico->serie;

      if($casoClinico->enfermera)
      $enfermera = "Enfermera: " . $casoClinico->enfermera->nombre . " " . $casoClinico->enfermera->primerApellido;

      // título
      $titulo = 'CONFIRMACION DE CODIGO';
      // mensaje
      $mensaje_medico = "<html>
                                <head>
                                    <title>CONFIRMACION DE CODIGO</title>
                                </head>
                                <body>
                                      <div class='contenedor'>
                                          <div><img src='http://democasosclinicos.online/imgmail/confirmacioncodigo.jpg'/></div>
                                          <p>Estimado Dr. <span> $medico </span></p>
                                          <p>
                                            Nos complace informar que el caso clinico folio $folio  se ha ligado  el(los)producto(s)</p>
                                             $sCodigo
                                             <p> te invitamos a dar seguimiento a tu caso e incrementar tus puntos en cada uno.
                                          </p>
                                          <p>Saludos</p>
                                          <a href='http://www.democasosclinicos.online'>www.casosclinicos.online</a>
                                      </div>
                                </body>
                          </html>";
      // mensaje
      $mensaje_alertas = "
                        <html>
                          <head>
                            <title>CONFIRMACION DE CODIGO</title>
                          </head>
                          <body>
                            <div class='contenedor'>
                              <div>
                                <img src='http://democasosclinicos.online/imgmail/confirmacioncodigo.jpg'/>
                              </div>
                              <p> Caso Clinico $folio del medico <span>  $medico </span>, $enfermera </p>
                              <p>Registro del Codigo(s)</p>
                                $sCodigo
                              <a href='http://www.democasosclinicos.online'>www.casosclinicos.online</a>
                            </div>
                          </body>
                        </html>
                        ";

      // Para enviar un correo HTML, debe establecerse la cabecera Content-type
      $cabeceras  = 'From: alertas@casosclinicos.online' . "\r\n" .
                    'Reply-To: alertas@casosclinicos.online' . "\r\n" .
                    'X-Mailer: PHP/' . " \r\n";
      $cabeceras .= 'MIME-Version: 1.0' . "\r\n";
      $cabeceras .= 'Content-type: text/html; charset=utf-8' . "\r\n";

      // Enviarlo charset=iso-8859-1
      mail($para_alertas, $titulo, $mensaje_alertas, $cabeceras);

      // Enviarlo
      mail($para_medico, $titulo, $mensaje_medico, $cabeceras);
  }
}
