<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\Diagnostico;

class DiagnosticosController
{
	public function ReadAll(Request $request, Response $response)
	{
		$diagnosticos = Diagnostico::all();
		
		return $response->getBody()->write(json_encode($diagnosticos));
	}
	public function Create(Request $request, Response $response)
	{
		$diagnosticoNuevo = $request->getParsedBody();

		$diagnostico = Diagnostico::create($diagnosticoNuevo);

		return $response->getBody()->write(json_encode($diagnostico));
	}
	public function Read(Request $request, Response $response)
	{
		$id = $request->getAttribute('id');

		$diagnostico = Diagnostico::find($id);

		return $response->getBody()->write(json_encode($diagnostico));
	}
	public function Update(Request $request, Response $response)
	{
		$id = $request->getAttribute('id');

		$diagnosticoUpdate = $request->getParsedBody();

		$diagnostico = Diagnostico::find($id);
		$diagnostico->update($diagnosticoUpdate);

		return $response->getBody()->write(json_encode($diagnostico));
	}
	public function Delete(Request $request, Response $response)
	{
		$id = $request->getAttribute('id');

		$diagnostico = Diagnostico::find($id);
		$diagnostico->delete();

		return $response->getBody()->write(json_encode($diagnostico));
	}
}