<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\Especialidad;

class EspecialidadesController
{
	public function ReadAll(Request $request, Response $response, $args)
	{
		$especialidades = Especialidad::all();

		return $response->getBody()->write(json_encode($especialidades));
	}
	public function Create(Request $request, Response $response, $args)
	{
		$especialidadNuevo = $request->getParsedBody();

		$especialidad = Especialidad::create($especialidadNuevo);

		return $response->getBody()->write(json_encode($especialidad));
	}
	public function Read(Request $request, Response $response, $args)
	{
		$id = $request->getAttribute('id');

		$especialidad = Especialidad::find($id);

		return $response->getBody()->write(json_encode($especialidad));
	}
	public function Update(Request $request, Response $response, $args)
	{
		$id = $request->getAttribute('id');
		$especialidadNuevo = $request->getParsedBody();

		$especialidad = Especialidad::find($id);
		$especialidad->update($especialidadNuevo);

		return $response->getBody()->write(json_encode($especialidad));
	}
	public function Delete(Request $request, Response $response, $args)
	{
		$id = $request->getAttribute('id');

		$especialidad = Especialidad::find($id);
		$especialidad->delete();

		return $response->getBody()->write(json_encode($especialidad));
	}
}