<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\Hospital;
use App\Models\Institucion;
use App\Models\CasoClinico;

class HospitalesController
{
  public function ReadAll(Request $request, Response $response, $args)
  {
    $hospitales = Hospital::all();
    $hospitales->loadMissing(['institucion', 'estado', 'casosclinicos']);

    return $response->getBody()->write(json_encode($hospitales));
  }
  public function Create(Request $request, Response $response, $args)
  {
     $hospitalNuevo = $request->getParsedBody();

     $hospital = Hospital::create($hospitalNuevo);

     return $response->getBody()->write(json_encode($hospital));
  }
  public function Read(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');

    $hospital = Hospital::find($id);
    $hospital->loadMissing(['institucion', 'estado', 'casosclinicos']);
    
    return $response->getBody()->write(json_encode($hospital));
  }
  public function Update(Request $request, Response $response, $args)
  {

    $id = $request->getAttribute('id');
    $hospitalUpdate =  $request->getParsedBody();

    $hospital = Hospital::find($id);
    $hospital->update($hospitalUpdate);

    return $response->getBody()->write(json_encode($hospital));
  }
  public function Delete(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');

    $hospital = Hospital::find($id);
    $hospital->delete();

    return $response->getBody()->write(json_encode($hospital));
  }
  public function ReadAllRelaciones(Request $request, Response $response, $args)
  {
    $hospitales = Hospital::all();

    $hospitales->loadMissing(['institucion', 'estado', 'casosclinicos']);

    return $response->getBody()->write(json_encode($hospitales));
  }
  public function Otros(Request $request, Response $response, $args)
  {
    $cc = CasoClinico::where('fk_hospital', 0)->get();

    return $response->getBody()->write(json_encode($cc));
  }
  public function Otro(Request $request, Response $response, $args)
  {
      $dato = $request->getParsedBody();

      $hospitalNuevo = $dato['hospital'];
      $casoClinicoUpdate = $dato['casoclinico'];

      $hospital = Hospital::create($hospitalNuevo);

      $institucion = Institucion::find($hospital->fk_institucion);

      $casoClinicoColumnsUpdate = [
                                  'fk_estado' => $hospital->fk_estado,
                                  'fk_institucion' => $hospital->fk_institucion,
                                  'cveInstitucion' => $institucion->cvInstitucion,
                                  'fk_hospital' => $hospital->id,
                                  'hospital' => $hospital->nomHospital];

      $id_casoclinico = $casoClinicoUpdate['id'];

      $casoClinico = CasoClinico::find($id_casoclinico);
      $casoClinico->update($casoClinicoColumnsUpdate);

      return $response->getBody()->write(json_encode($hospital));
  }


  public function filtro(Request $request, Response $response, $args)
  {
    $fk_edo = $request->getAttribute('id');

    $hospitales = Hospital::where('fk_estado', $fk_edo)->get();

    return $response->getBody()->write(json_encode($hospitales));
  }

}
