<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\Institucion;
use App\Models\CasoClinico;

class InstitucionesController
{
	public function ReadAll(Request $request, Response $response)
	{
		$instituciones = Institucion::all();
		$instituciones->loadMissing(['hospitales']);

		return $response->getBody()->write(json_encode($instituciones));
	}
	public function Create(Request $request, Response $response)
	{
        $institucionNuevo  =  $request->getParsedBody();

	    $institucion = Institucion::create($institucionNuevo);

	    return $response->getBody()->write(json_encode($institucion));
  	}
  	public function Read(Request $request, Response $response, $args)
  	{
	    $id = $request->getAttribute('id');
	    
	    $institucion = Institucion::find($id);
	  	$institucion->loadMissing(['hospitales']);

	    return $response->getBody()->write(json_encode($institucion));
  	}
  	public function Update(Request $request, Response $response, $args)
  	{
   
	    $id = $request->getAttribute('id');
	    $institucionUpdate =  $request->getParsedBody(); 
	    
	    $institucion = Institucion::find($id);
	    $institucion->update($institucionUpdate);
	    
	    return $response->getBody()->write(json_encode($institucion));   
  	}
  	public function Delete(Request $request, Response $response, $args)
  	{
	    $id = $request->getAttribute('id');
	    
	    $institucion = Institucion::find($id);
	    $institucion->delete();
	    
	    return $response->getBody()->write(json_encode($institucion));
  	}
  	public function Otros(Request $request, Response $response, $args)
  	{
    	$cc = CasoClinico::where('fk_institucion', 0)->get();

    	return $response->getBody()->write(json_encode($cc));
  	}
  	public function Otro(Request $request, Response $response, $args)
  	{
  		
  		$dato = $request->getParsedBody();

  		$institucionNuevo = $dato['institucion'];
  		$casoClinicoUpdate = $dato['casoclinico'];

  		$institucion = Institucion::create($institucionNuevo);

  		$casoClinicoColumnsUpdate = [
  									'fk_institucion' => $institucion->id, 
  									'cveInstitucion' => $institucion->cvInstitucion];

  		$id_casoclinico = $casoClinicoUpdate['id'];

  		$casoClinico = CasoClinico::find($id_casoclinico);
  		$casoClinico->update($casoClinicoColumnsUpdate); 

  		return $response->getBody()->write(json_encode($institucion));
  	}
}  	