<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\SeguimientoPostOperatorio;
use Carbon\Carbon;


class SeguimientosPostOperatorioController
{
  public function Create(Request $request, Response $response, $args)
  {

    $seguimientoNuevo = $request->getParsedBody();
    $seguimientoNuevo["fechaRegistro"] = Carbon::now();
  	$seguimiento = SeguimientoPostOperatorio::create($seguimientoNuevo);

  	return $response->getBody()->write(json_encode($seguimiento));
  }
  public function Read(Request $request, Response $response, $args)
  {
  	$id = $request->getAttribute('id');
  	$seguimiento = SeguimientoPostOperatorio::find($id);

  	return $response->getBody()->write(json_encode($seguimiento));

  }
  public function Update(Request $request, Response $response, $args)
  {
  	$id = $request->getAttribute('id');
  	$seguimientoUpdate = $request->getParsedBody();

  	$seguimiento = SeguimientoPostOperatorio::find($id);
  	$seguimiento->update($seguimientoUpdate);

  	return $response->getBody()->write(json_encode($seguimiento));

  }
  public function Delete(Request $request, Response $response, $args)
  {
  	$id = $request->getAttribute('id');

  	$seguimiento = SeguimientoPostOperatorio::find($id);
    $seguimiento->delete();

    return $response->getBody()->write(json_encode($seguimiento));

  }
  public function UpFile(Request $request, Response $response, $args)
  {
    $res = [
            "code" => 0,
            "message" => "No se cumplio la funcion",
            "data" => null
          ];

    $fk_casoClinico   = $request->getParam('fk_casoClinico');
    $fk_tipoDocumento = $request->getParam('fk_tipoDocumento');
    $descDocumento    = $request->getParam('descDocumento');
    $fechaDocumento   = $request->getParam('fechaDocumento');
    $seccion          = $request->getParam('seccion');
    $noSeguimiento    = $request->getParam('noSeguimiento');

    $files = $request->getUploadedFiles();
    $file = $files['file'];

    if ($file->getError() === UPLOAD_ERR_OK)
    {

      $path = $_SERVER['DOCUMENT_ROOT'] . '/img/';

      $media = $file->getClientMediaType();

      $extension = pathinfo($file->getClientFilename(), PATHINFO_EXTENSION);
      $basename = 'cc' . $fk_casoClinico . $fk_tipoDocumento . strval(mt_rand());
      $filename = sprintf('%s.%0.8s', $basename, $extension);
      $size = $file->getSize();

      $file->moveTo( $path . $filename );

      $ruta = '/img/' . $filename;

      $documento = new DocumentoCasoClinico();

      $documento->fk_casoClinico = $fk_casoClinico;
      $documento->fk_tipoDocumento = $fk_tipoDocumento;
      $documento->descDocumento = $descDocumento;
      $documento->nomDocumento = $filename;

      $documento->ruta = $ruta;
      $documento->media = $media;
      $documento->extension = $extension;
      $documento->tamano = $size;
      $documento->fechaDocumento = $fechaDocumento;
      $documento->fechaRegistro =  Carbon::now();
      $documento->seccion  = $seccion;
      $documento->noSeguimiento = $noSeguimiento;

      if($documento->save())
      {
        $res["code"] = 1;
        $res["message"] = "Registrado con exito";
        $res["data"] = $documento;
      }
      else
      {
        $res["code"] = 0;
        $res["message"] = "No se registrado";
        $res["data"] = $documento;
      }
    }
    return $response->getBody()->write(json_encode($res));
  }
  public function uploadFile(Request $request, Response $response, $args)
  {

    $files = $request->getUploadedFiles(); //array UploadedFile

    $file = $files['imagen'];

    $media = $file->getClientMediaType();
    $size = $file->getSize();
    $name = $file->getClientFilename();
    $error = $file->getError();
    $extension = pathinfo($file->getClientFilename(), PATHINFO_EXTENSION);
    //echo   $media, ' ', $size, ' ', $name, ' ', $error, ' ', $extension;
    if($file->getError() === UPLOAD_ERR_OK)
    {
        $this->moveUploadFile($file);
    }
    echo var_dump($files);
  }
  private function moveUploadFile(UploadedFile $upLoadedFile)
  {
        $path = $_SERVER['DOCUMENT_ROOT'] . '/img/';
        $upLoadedFile->moveTo($path . $upLoadedFile->getClientFilename());
        return $upLoadedFile->getClientFilename();
  }

}
