<?php
namespace App\Controllers;

use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

use App\Models\Venta;
use App\Models\Producto;
use App\Models\Batch;

class VentasController
{
  public function ReadAll(Request $request, Response $response, $args)
  {
    $ventas = Venta::all();

    $ventas->loadMissing(['productos', 'batch', 'institucion']);

    return $response->getBody()->write(json_encode($ventas));
  }
  public function Create(Request $request, Response $response, $args)
  {
      $venta_nuevo = $request->getParsedBody();
      //$codigo = $request->getParam('codigo');  $args['codigo'];
      $venta = Venta::create($venta_nuevo);

      return $response->getBody()->write(json_encode($venta));
  }
  public function Read(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id', '0');

    $venta = Venta::find($id);

    $venta->loadMissing(['productos', 'batch', 'institucion']);

    return $response->getBody()->write(json_encode($venta));
  }
  public function Update(Request $request, Response $response, $args)
  {
    $id = $request->getAttribute('id');

    $venta_actualizar = $request->getParsedBody();
    //$nomProducto = $request->getParam('nomProducto'); $args['nomProducto'];

    $venta = venta::find($id);
    $venta->update($venta_actualizar);

    return $response->getBody()->write(json_encode($venta));
  }
  public function Delete(Request $request, Response $response, $args)
  {
    $mensaje = [];
    $id = $request->getAttribute('id');

    $venta = Venta::find($id); //or Producto::destroy($id);
    $venta->delete();

    return $response->getBody()->write(json_encode($venta));
  }
  public function Cancelar(Request $request, Response $response, $args)
  {
    $mensaje = [];
    $id = $request->getAttribute('id');

    $venta = Venta::find($id);
    $venta->update(['status' => 0, 'tipo_mov' => 0]);
    $venta->productos()->where('status', 1)->update(['status' => 0, 'tipo_mov' => 0]);

    return $response->getBody()->write(json_encode($venta));
  }

  //funcionalidad  cancelada sin uso
  public function Cambio(Request $request, Response $response, $args)
  {
    $mensaje = [];
    $id = $request->getAttribute('id');

    $venta = Venta::find($id);
    $venta->update(['tipo_mov'=> 2]);

    return $response->getBody()->write( json_encode($venta) );
  }
}
