<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class CasoClinico extends Model
{
	protected $guarded = ['id'];
	protected $table = 'CasosClinicos';
	protected $primaryKey = 'id';

	public $timestamps = true;

	public function productos()
	{
    return $this->hasMany(Producto::class, 'fk_casoClinico');
  }
	public function seguimientos()
	{
  	return $this->hasMany(SeguimientoPostOperatorio::class, 'fk_casoClinico');
  }
	public function documentos()
	{
  	return $this->hasMany(DocumentoCasoClinico::class, 'fk_casoClinico');
	}
	public function medico()
	{
    return $this->belongsTo(Medico::class, 'fk_medico');
  }
	public function enfermera()
	{
		return $this->belongsTo(Enfermera::class, 'fk_enfermera');
	}
	public function estado()
	{
  return $this->belongsTo(Estado::class, 'fk_estado');
  }
	public function centromedico()
	{
		return $this->belongsTo(Hospital::class, 'fk_hospital');
	}
	public function institucion()
	{
		return $this->belongsTo(Institucion::class, 'fk_institucion');
	}

}
