<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Enfermera extends Model
{
  protected $guarded = ['id'];
  protected $table = 'Enfermeras';
  protected $primaryKey = 'id';

  public $timestamps = true;

  public function nombreCompleto()
  {
    return $this->nombre . ' ' . $this->primerApellido . ( $this->segundoApellido ? ' ' .  $this->segundoApellido : '');
  }
  public function productos()
  {
    return $this->hasMany(Producto::class, 'fk_enfermera');
  }
  public function redimirenfermera()
  {
    return $this->hasMany(RedimirEnfermera::class, 'fk_enfermera');
  }
  public function casosclinicos()
  {
    return $this->hasMany(CasoClinico::class, 'fk_enfermera');
  }
  public function medicos()
  {
    return $this->belongsToMany(Medico::class, 'EnfermerastoMedicos', 'fk_enfermera', 'fk_medico');
  }
  public function supervisor()
  {
    return $this->belongsTo(Supervisor::class, 'fk_supervisor');
  }
  public function usuario()
  {
    return $this->belongsTo(Usuario::class, 'fk_usuario');
  }
}
