<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Medico extends Model
{
  protected $guarded = ['id'];
  protected $table = 'Medicos';
  protected $primaryKey = 'id';

  public $timestamps = true;

  public function nombreCompleto()
  {
    return $this->nombre .  ' ' . $this->primerApellido . ( $this->segundoApellido ? ' ' .  $this->segundoApellido : '');
  }
  public function productos()
  {
    return $this->hasMany(Producto::class, 'fk_medico');
  }
  public function redimirmedico()
  {
    return $this->hasMany(RedimirMedico::class, 'fk_medico');
  }
  public function casosclinicos()
  {
    return $this->hasMany(CasoClinico::class, 'fk_medico');
  }
  public function enfermeras()
  {
    return $this->belongsToMany(Enfermera::class, 'EnfermerastoMedicos', 'fk_medico', 'fk_enfermera');
  }
  public function usuario()
  {
    return $this->belongsTo(Usuario::class, 'fk_usuario');
  }
  public function puesto()
  {
    return $this->belongsTo(Puesto::class, 'fk_puesto');
  }
  public function residencia()
  {
    return $this->belongsTo(Residencia::class, 'fk_residencia');
  }

}
