<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Usuario extends Model
{
  protected $guarded = ['id'];
  protected $table = 'Usuarios';
  protected $primaryKey = 'id';

  public $timestamps = true;

  public function medico()
  {
    return $this->hasOne(Medico::class, 'fk_usuario');
  }
  public function enfermera()
  {
    return $this->hasOne(Enfermera::class, 'fk_usuario');
  }
  public function supervisor()
  {
    return $this->hasOne(Supervisor::class, 'fk_usuario');
  }
  public function documentos()
  {
      return $this->hasMany(DocumentoUsuario::class, 'fk_usuario');
  }
  public function rol()
  {
    return $this->belongsTo(Rol::class, 'fk_rol');
  }

}
